program VesaTest;

uses Crt, VESAUnit;

var
  X, Y : Word;

begin
  ClrScr;
  {Check for the existence of a VESA driver}
  if not IsVBE then begin
    Writeln ('VESA driver not installed.');
    Halt;
  end;
  {Check whether 640x480x256 mode is supported}
  if not (SupportVideoMode ($101)) then begin
    Writeln ('VESA 640x480x256 mode not supported.');
    Halt;
  end;
  {Switch to said mode}
  if not (VESASetMode ($101)) then begin
    Writeln ('Could not switch to VESA 640x480x256 mode.');
    Halt;
  end;
  {Draw a pattern}
  for y := 0 to 255 do
    for x := 0 to 319 do
      VESAPutPixel (x, y, x or y);
  for y := 0 to 255 do
    for x := 320 to 639 do
      VESAPutPixel (x, y, x + y);
  for y := 256 to 479 do
    for x := 0 to 319 do
      VESAPutPixel (x, y, x xor y);
  for y := 256 to 479 do
    for x := 320 to 639 do
      VESAPutPixel (x, y, x and y);
  {Wait for a keypress}
  ReadKey;
  {Return to text mode}
  VESASetMode ($3);
end.